#ifndef INTERRUPTED_FILE_H
#define INTERRUPTED_FILE_H

#include <string>

class InterruptedFile
{
 public:
  InterruptedFile(std::string file);

  const std::string      filename();
  const std::string      ext();
  const std::string      strsize(bool comma = true);
  const unsigned long    size();
  const std::string      strprogress(int precision = 1);
  const double           progress();
  const unsigned long    read();
  const unsigned long    toread();
  const std::string      ip();
  const bool             isValid();
  const std::string      completeName();

  //! Increments the number of query hits which are equal to this file.
  const void             incFound();

  //! Decrements the number of query hits which are equal to this file.
  const void             decFound();

  const void             setColored();

  const void             clearColored();

  const int              getColored();

  const int              getFound();

 private:
  std::string  _filename;
  int          _found;
  int          _colored;
};

#endif
